package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ChainParams")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ChainParams implements Marshallable {
	private byte[] data;
	private boolean isUpdate;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getData() {
	    return data;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setData(final byte[] value) {
	    this.data = value;
	}

	public ChainParams data(final byte[] value) {
	    setData(value);
	    return this;
	}
	public ChainParams data(final String value) {
		try {
			setData(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public boolean getIsUpdate() {
	    return isUpdate;
	}
	public void setIsUpdate(final boolean value) {
	    this.isUpdate = value;
	}

	public ChainParams isUpdate(final boolean value) {
	    setIsUpdate(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.data == null || this.data.length == 0)) {
            marshaller.writeBytes(1, this.data);
        }
        if (!(!this.isUpdate)) {
            marshaller.writeBool(2, this.isUpdate);
        }
        return marshaller.array();
    }
}
